# -*- coding: utf-8 -*-
# konfigurationKlassenKarte.py
import  wx

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)


class KonfigurationKlassenKarte(wx.Dialog):
    def __init__(
            self, parent,
            ID, title, size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, "Konfiguration der Objektdaten")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        # x-Koordinate
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "x-Position")
        label.SetHelpText(u"Ändern Sie die x-Koordinate")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        # damit die Werte auszulesen sind, muessen sie Instanzvariable sein
        self.textX = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textX.SetHelpText("Wert der x-Koordinate")
        box.Add(self.textX, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # y-Koordinate
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "y-Position")
        label.SetHelpText("Aendern Sie die y-Koordinate")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textY = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textY.SetHelpText("Wert der y-Koordinate")
        box.Add(self.textY, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Breite
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Breite      ")
        label.SetHelpText("Aendern Sie die Breite")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textBreite = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textBreite.SetHelpText("Wert der Breite")
        box.Add(self.textBreite, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Abstrakt ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "abstrakt ?")
        label.SetHelpText(u"auswählen, ob")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbAbstrakt = wx.CheckBox(self, -1, "ist abstrakt", size=(280,-1))
        self.cbAbstrakt.SetHelpText("Abstrakt")
        box.Add(self.cbAbstrakt, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Trennlinie
        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()
        
        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)
        
        okbtn = wx.Button(self, wx.ID_OK)
        okbtn.SetHelpText("Beenden und uebernehmen")
        okbtn.SetDefault()
        btnsizer.AddButton(okbtn)
        self.Bind(wx.EVT_BUTTON, self.OnOKButton, okbtn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("Abbruch ohne die Werte zu uebernehmen")
        btnsizer.AddButton(btn)
        btnsizer.Realize()
        self.Bind(wx.EVT_BUTTON, self.OnCancelButton, btn)

        sizer.Add(btnsizer, 0, wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

    def DatenSetzen(self, x, y, breite, abstrakt):
        self.textX.ChangeValue(x)
        self.textY.ChangeValue(y)
        self.textBreite.ChangeValue(breite)
        self.cbAbstrakt.SetValue(abstrakt)

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)
