# -*- coding: utf-8 -*-
# konfigurationMethode.py
import platform
versionsNummer=platform.python_version()[0]
### Kommentar zum Einfuegen neuer Parameter bei Py3
### Ich kann mir zwar vorstellen, was dahinter steckt,
### dass Py3 immer am Anfang der Liste neue Elemente einfuegt,
### habe aber keine Lust das hier zu heilen.
### Leider steckt die Verwaltung im Hintergrund und ist fuer
### mich nicht so leicht auszutricksen.
import sys
import  wx
import  wx.lib.mixins.listctrl  as  listmix

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)

#---------------------------------------------------------------------------
class ParameterListCtrl(wx.ListCtrl,
                   listmix.ListCtrlAutoWidthMixin,
                   listmix.TextEditMixin
                   ):

    def __init__(self, parent, ID, pos=wx.DefaultPosition,
                 size=wx.DefaultSize, style=0, daten=[]):
        wx.ListCtrl.__init__(self, parent, ID, pos, size, style)
        self.daten=daten
        self.listctrldata=dict()
        self.SetzeDaten(daten)

        listmix.ListCtrlAutoWidthMixin.__init__(self)

        self.InsertColumn(0, "Parameter")
        self.InsertColumn(1, "   Typ   ")

        self.Erzeuge()

        self.SetColumnWidth(0, 100)
        self.SetColumnWidth(1, 100)
        self.currentItem = 0
        listmix.TextEditMixin.__init__(self)

    def Erzeuge(self):
        items = self.listctrldata.items()
        ## Fuer Py3 geht nichtsys.maxint
        index=0 # nur initialisieren
        if versionsNummer=='2':           
            for key, data in items:
                    index = self.InsertStringItem(sys.maxint, data[0])
                    self.SetStringItem(index, 0, data[0])
                    self.SetStringItem(index, 1, data[1])
                    self.SetItemData(index, key)
        else:
            ## Kommentar s.o.
            for key, data in items:
                index = self.InsertItem(self.GetItemCount(), data[0])
                self.SetItem(index, 0, data[0])
                self.SetItem(index, 1, data[1])
                self.SetItemData(index, key)
            
    def SetStringItem(self, index, col, data):
        if col in range(2):
            if versionsNummer=='2':
                wx.ListCtrl.SetStringItem(self, index, col, data)
            else:
                wx.ListCtrl.SetItem(self, index, col, data)

    def SetzeDaten(self, daten):
        '''[("Parameter1","Typ1") ...]'''
        self.listctrldata = dict()
        for index in range(len(daten)):
            self.listctrldata.update({index:daten[index]})

    def VerlaengereDaten(self):
        self.DeleteAllItems()
        neu=('name','typ')
        self.daten.append(neu)
        self.listctrldata.update({len(self.listctrldata):neu})
        self.Erzeuge()

    def GibDaten(self):
        daten=[]
        for zeile in range(len(self.listctrldata)):
            daten.append(
                (self.GetItem(zeile,0).GetText(),
                 self.GetItem(zeile,1).GetText())
                )
        return daten


### -------------------------------------------------------------
class KonfigurationMethode(wx.Dialog):
    def __init__(
            self, parent,
            ID, title,
            name,typ,parameterliste,abstrakt,isClassMeth,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):
        
        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        # Name
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Name")
        label.SetHelpText(u"Ändern Sie den Namen")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textName = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textName.SetHelpText("Methodenname")
        box.Add(self.textName, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.textName.ChangeValue(name)
        
        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        #  Typ
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Typ")
        label.SetHelpText("Aendern Sie den Typ")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textTyp = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textTyp.SetHelpText("Typ der Methode")
        box.Add(self.textTyp, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.textTyp.ChangeValue(typ)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Parameter
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Konfiguration der Parameter")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        neuButton = wx.Button(self, -1,'neuer Parameter')
        neuButton.SetHelpText("neuer Parameter")
        box.Add(neuButton)
        self.Bind(wx.EVT_BUTTON, self.OnNeuerParameter, neuButton)
        
        label = wx.StaticText(self, -1, "ohne Parameter: Vorgabe lassen oder leer")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Parameterliste
        self.git=ParameterListCtrl(self, -1,
                                   style=wx.LC_REPORT
                                   | wx.BORDER_NONE
                                   | wx.LC_SORT_ASCENDING,
                                   daten=eval(parameterliste)
                                   )
        sizer.Add(self.git, 1, wx.EXPAND)
        
        # Abstrakt ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "abstrakt ?")
        label.SetHelpText(u"auswählen, wenn")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbAbstrakt = wx.CheckBox(self, -1, "ist abstrakt", size=(280,-1))
        self.cbAbstrakt.SetHelpText("Abstrakt")
        box.Add(self.cbAbstrakt, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.cbAbstrakt.SetValue(abstrakt)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Klassenmethode ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Klassenmethode ?")
        label.SetHelpText(u"auswählen, wenn")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbClMeth = wx.CheckBox(self, -1, "ist Klassenmethode", size=(280,-1))
        self.cbClMeth.SetHelpText("Klassenmethode")
        box.Add(self.cbClMeth, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.cbClMeth.SetValue(isClassMeth)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        
        # Trennlinie
        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()
        
        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)
        
        okbtn = wx.Button(self, wx.ID_OK)
        okbtn.SetHelpText("Beenden und uebernehmen")
        okbtn.SetDefault()
        btnsizer.AddButton(okbtn)
        self.Bind(wx.EVT_BUTTON, self.OnOKButton, okbtn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("Abbruch ohne die Werte zu uebernehmen")
        btnsizer.AddButton(btn)
        btnsizer.Realize()
        self.Bind(wx.EVT_BUTTON, self.OnCancelButton, btn)

        sizer.Add(btnsizer, 0, wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

    def OnNeuerParameter(self, evt):
        self.git.SetzeDaten(self.git.GibDaten())
        aktuelleDaten=self.git.VerlaengereDaten()

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)

