# -*- coding: utf-8 -*-
# konfigurationVerbinder.py
import  wx

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)


class KonfigurationVerbinder(wx.Dialog):
    def __init__(
            self, parent,
            ID, title,
            s,sk,st,z,zk,zt,name,typ,verbTyp,ri,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)
        self.s,self.sk,self.st=s,sk,st
        self.z,self.zk,self.zt=z,zk,zt
        self.name,self.typ,self.verbTyp,self.ri=name,typ,verbTyp,ri

        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, "Konfiguration des Verbinders\n von   "+
                              s+"    zu   "+z)
        sizer.Add(label, 0, wx.ALL, 5)
        
        # Kanten
        self.kanten=["N","O","S","W"]

        box = wx.BoxSizer(wx.HORIZONTAL)
        self.rb1 = wx.RadioBox(
                self, -1, "Startkante", wx.DefaultPosition, wx.DefaultSize,
                self.kanten, 4
                )        
        self.Bind(wx.EVT_RADIOBOX, self.EvtRadioBox1, self.rb1)
        box.Add(self.rb1, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.rb1.SetSelection(self.kanten.index(self.sk))

        self.rb2 = wx.RadioBox(
                self, -1, "Zielkante", wx.DefaultPosition, wx.DefaultSize,
                self.kanten, 4
                )        
        self.Bind(wx.EVT_RADIOBOX, self.EvtRadioBox2, self.rb2)
        box.Add(self.rb2, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.rb2.SetSelection(self.kanten.index(self.zk))
        sizer.Add(box, 0, wx.ALL, 5)        

        # Startteiler
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Teiler Startkante")
        label.SetHelpText(u"0 .. 100")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        self.textTeilerStart = wx.TextCtrl(self, -1, "", size=(20,-1))
        self.textTeilerStart.SetHelpText("0 .. 100")
        self.textTeilerStart.SetValue(self.st)
        self.Bind(wx.EVT_TEXT, self.EvtTextTeilerStart, self.textTeilerStart)
        box.Add(self.textTeilerStart, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        # Zielteiler
        
        label = wx.StaticText(self, -1, "Teiler Zielkante")
        label.SetHelpText(u"0 .. 100")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        self.textTeilerZiel = wx.TextCtrl(self, -1, "", size=(20,-1))
        self.textTeilerZiel.SetHelpText("Teiler Zielkante")
        self.textTeilerZiel.SetValue(self.zt)
        self.Bind(wx.EVT_TEXT, self.EvtTextTeilerZiel, self.textTeilerZiel)
        box.Add(self.textTeilerZiel, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Typen
        self.typen=["Assoziation","Aggregation","Komposition","Vererbung"]
        box = wx.BoxSizer(wx.HORIZONTAL)
        self.rb3 = wx.RadioBox(
                self, -1, "Typen", wx.DefaultPosition, wx.DefaultSize,
                self.typen, 4
                )        
        self.Bind(wx.EVT_RADIOBOX, self.EvtRadioBox3, self.rb3)
        box.Add(self.rb3, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.rb3.SetSelection(self.typ)
        sizer.Add(box, 0, wx.ALL, 5)        

        # Verbindertyp        
        self.verbinderTypen=["Gerade","einfacher Winkel","Doppelwinkel"]
        box = wx.BoxSizer(wx.HORIZONTAL)
        self.rb4 = wx.RadioBox(
                self, -1, "Verbindertypen", wx.DefaultPosition, wx.DefaultSize,
                self.verbinderTypen, 3
                )        
        self.Bind(wx.EVT_RADIOBOX, self.EvtRadioBox4, self.rb4)
        box.Add(self.rb4, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.rb4.SetSelection(self.verbTyp)

        # Richtung (nicht bei Vererbung!)
        self.cb1 = wx.CheckBox(self, -1, "gerichtet")
        self.Bind(wx.EVT_CHECKBOX, self.EvtCheckBox, self.cb1)
        box.Add(self.cb1, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        sizer.Add(box, 0, wx.ALL, 5)
        self.cb1.SetValue(False)
        if self.verbTyp!=2:
            if self.ri==1:
                self.cb1.SetValue(True)
        
        # Trennlinie
        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()
        
        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)
        
        okbtn = wx.Button(self, wx.ID_OK)
        okbtn.SetHelpText("Beenden und uebernehmen")
        okbtn.SetDefault()
        btnsizer.AddButton(okbtn)
        self.Bind(wx.EVT_BUTTON, self.OnOKButton, okbtn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("Abbruch ohne die Werte zu uebernehmen")
        btnsizer.AddButton(btn)
        btnsizer.Realize()
        self.Bind(wx.EVT_BUTTON, self.OnCancelButton, btn)

        sizer.Add(btnsizer, 0, wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

    def EvtTextTeilerStart(self, event):
        self.st=self.textTeilerStart.GetValue()

    def EvtTextTeilerZiel(self, event):
        self.zt=self.textTeilerZiel.GetValue()

    def EvtRadioBox1(self, event):
        '''nicht dieselbe Kante'''
        i=event.GetInt()
        if i==self.rb2.GetSelection():
            self.rb1.SetSelection(self.kanten.index(self.sk))
        else:
            self.sk=self.kanten[i]

    def EvtRadioBox2(self, event):
        '''nicht dieselbe Kante'''
        i=event.GetInt()
        if i==self.rb1.GetSelection():
            self.rb2.SetSelection(self.kanten.index(self.zk))
        else:
            self.zk=self.kanten[i]

    def EvtRadioBox3(self, event):
        '''Typen'''
        i=event.GetInt()
        self.typ=i
        #keine Richtung bei Vererbung
        if i==3:
            self.ri=0
            ## ToDo Radiobutton setzen

    def EvtRadioBox4(self, event):
        '''Verbindertypen'''
        i=event.GetInt()
        #kein Doppelwinkel bei NO,SW usw
        if i==2:
            if (self.sk,self.zk) in [
                ('N','O'),('N','W'),('S','O'),('S','W'),
                ('O','N'),('W','N'),('O','S'),('W','S')
                ]:
               self.rb4.SetSelection(self.verbTyp)
        self.verbTyp=i

    def EvtCheckBox(self,event):
        '''Richtung nicht bei Vererbung'''
        if self.typ==3:
            self.cb1.SetValue(False)
            return
        if self.cb1.GetValue():
            print(self.cb1.GetValue())
            self.ri=1
        else: self.ri=0

    def DatenSetzen(self, s, sk, st, z, zk, zt, name, typ, verbTyp, ri):
        self.s,self.sk,self.st=s,sk,st
        self.z,self.zk,self.zt=z,zk,zt
        self.name,self.typ,self.verbTyp,self.ri=name,typ,verbTyp,ri

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)
